#!/usr/bin/python
import urllib
import urllib2

class revlib_server:
    def __init__( self, host ):
        self.host = host

    def list_functions( self, inputs_ge = None, inputs_le = None, outputs_ge = None, outputs_le = None, cubes_ge = None, cubes_le = None ):
        import json

        queries = []
        if inputs_ge:
            queries.append( "inputs_ge=%d" % inputs_ge )
        if inputs_le:
            queries.append( "inputs_le=%d" % inputs_le )
        if outputs_ge:
            queries.append( "outputs_ge=%d" % outputs_ge )
        if outputs_le:
            queries.append( "outputs_ge=%d" % outputs_le )
        if cubes_ge:
            queries.append( "cubes_ge=%d" % cubes_ge )
        if cubes_le:
            queries.append( "cubes_ge=%d" % cubes_le )

        functions = json.loads( urllib2.urlopen( self.host + "/functions.json?" + "&".join( queries ) ).read() )

        return [ { 'name': f["function"]["name"], \
                   'url': self.host + f["function"]["url"], \
                   'inputs': f["function"]["inputs"], \
                   'outputs': f["function"]["outputs"], \
                   'cubes': f["function"]["cubes"] \
                       } for f in [ json.loads( f ) for f in functions ] ]

    def add_function( self, name, filename, inputs = 0, outputs = 0, cubes = 0 ):
        from poster.encode import multipart_encode
        from poster.streaminghttp import register_openers
        
        register_openers()
        
        url = self.host + "/functions"
        values = { 'function_file': open( filename, "r" ) }
        
        data, headers = multipart_encode( values )
        req = urllib2.Request( url, data, headers )
        response = urllib2.urlopen( req )
        
        # Update name
        url = response.geturl()
        urllib2.urlopen( url + "/edit" )
        values = { 'function[name]': name, 'function[inputs]': inputs, 'function[outputs]': outputs, 'function[cubes]': cubes }
        req = urllib2.Request( url, urllib.urlencode( values ) )
        req.get_method = lambda: 'PUT'
        opener = urllib2.build_opener(urllib2.HTTPHandler)
        try:
            response = opener.open( req )
        except urllib2.HTTPError:
            pass

if __name__ == "__main__":
    from revkit import *
    import os
    from tempfile import NamedTemporaryFile

    server = revlib_server( "http://localhost:3000" )
#    server = revlib_server( "http://evening-leaf-819.heroku.com" )
    # for name, filename in server.list_functions():
    #     with open( '/tmp/revlib/kfdd/%s.pla' % name, 'w' ) as f:
    #         f.write( urllib2.urlopen( filename ).read() ) 
    #         f.close()
    
    path = "/tmp/revlib/kfdd/"
    for filename in os.listdir( "/tmp/revlib/kfdd/" ):
        spec = binary_truth_table()
        read_pla( spec, path + filename, extend = False )

        inputs = spec.num_inputs
        outputs = spec.num_outputs
        cubes = sum( 1 for _ in spec.entries )

        print filename
        server.add_function( filename[:filename.rfind( '_' )], path + filename, inputs, outputs, cubes )
